# -*- coding: utf-8 -*-
"""
Created on Sun Apr  7 15:15:29 2019

@author: JCxie
"""

import matplotlib.pyplot as plt
import numpy as np
from sklearn import datasets, linear_model,cross_validation
iris=datasets.load_iris() # 使用 scikit-learn 自带的 iris 数据集
X_train=iris.data
y_train=iris.target
X_train,X_test,y_train,y_test = cross_validation.train_test_split(iris.data,iris.target,test_size=0.25,random_state=0)
Cs=np.logspace(-2,4,num=100)
scores=[]
for C in Cs:
    regr = linear_model.LogisticRegression(C=C)
    regr.fit(X_train, y_train)
    scores.append(regr.score(X_test, y_test))
    ## 绘图

fig=plt.figure(1, figsize=(8, 6))
ax=fig.add_subplot(1,1,1)
ax.plot(Cs,scores)
ax.set_xlabel(r"C")
ax.set_ylabel(r"score")
ax.set_xscale('log')
ax.set_title("LogisticRegression")
plt.show() 
print('Coefficients:%s, intercept %s'%(regr.coef_,regr.intercept_))
print('Score: %.2f' % regr.score(X_test, y_test))


####可视化#####
logreg = linear_model.LogisticRegression(C=1e5, solver='lbfgs', multi_class='multinomial')
logreg.fit(X_train[:, :2], y_train)
x_min, x_max = X_train[:, 0].min() - .5, X_train[:, 0].max() + .5
y_min, y_max = X_train[:, 1].min() - .5, X_train[:, 1].max() + .5
h = .02  # step size in the mesh
xx, yy = np.meshgrid(np.arange(x_min, x_max, h), np.arange(y_min, y_max, h))
Z = logreg.predict(np.c_[xx.ravel(), yy.ravel()])
Z = Z.reshape(xx.shape)
plt.figure(2, figsize=(8, 6))
plt.pcolormesh(xx, yy, Z, cmap=plt.cm.Paired)
plt.scatter(X_train[:, 0], X_train[:, 1], c=y_train, edgecolors='k', cmap=plt.cm.Paired)
plt.xlabel('Sepal length')
plt.ylabel('Sepal width')

plt.xlim(xx.min(), xx.max())
plt.ylim(yy.min(), yy.max())
plt.xticks(())
plt.yticks(())

plt.show()